searchNodes=[{"doc":"Documentation for Measurements . A measurement is a quantity represented, by a value, a unit and an error. The value is usually an integer to maintain maximum precision, but can also be a float if required. Examples iex&gt; Measurements . time ( 42 , :second ) % Measurements { value : 42 , unit : :second , error : 0 }","ref":"Measurements.html","title":"Measurements","type":"module"},{"doc":"Add error to a Measurement. The error is symmetric and always represented by a positive number. The measurement unit is converted if needed to not loose precision. Examples iex&gt; Measurements . time ( 42 , :second ) |&gt; Measurements . add_error ( - 4 , :millisecond ) % Measurements { value : 42_000 , unit : :millisecond , error : 4 }","ref":"Measurements.html#add_error/3","title":"Measurements.add_error/3","type":"function"},{"doc":"Convert the measurement to the new unit, if the new unit is more precise. This will pick the most precise between the measurement's unit and the new unit. Then it will convert the measurement to the chosen unit. If no conversion is possible, the original measurement is returned. Examples iex&gt; Measurements . time ( 42 , :second ) |&gt; Measurements . add_error ( 1 , :second ) |&gt; Measurements . best_convert ( :millisecond ) % Measurements { value : 42_000 , unit : :millisecond , error : 1_000 } iex&gt; Measurements . time ( 42 , :millisecond ) |&gt; Measurements . add_error ( 1 , :millisecond ) |&gt; Measurements . best_convert ( :second ) % Measurements { value : 42 , unit : :millisecond , error : 1 }","ref":"Measurements.html#best_convert/2","title":"Measurements.best_convert/2","type":"function"},{"doc":"The difference of two measurements, with implicit unit conversion. Only measurements with the same unit dimension will work. Error will be propagated (ie compounded). Examples iex&gt; m1 = Measurements . time ( 42 , :second ) |&gt; Measurements . add_error ( 1 , :second ) iex&gt; m2 = Measurements . time ( 543 , :millisecond ) |&gt; Measurements . add_error ( 3 , :millisecond ) iex&gt; Measurements . delta ( m1 , m2 ) % Measurements { value : 41_457 , unit : :millisecond , error : 1_003 }","ref":"Measurements.html#delta/2","title":"Measurements.delta/2","type":"function"},{"doc":"Length Measurement. Examples iex&gt; Measurements . length ( 42 , :meter ) % Measurements { value : 42 , unit : :meter }","ref":"Measurements.html#length/3","title":"Measurements.length/3","type":"function"},{"doc":"Generic Measurement. Unit indicates the dimension. Examples iex&gt; Measurements . new ( 42 , :meter ) % Measurements { value : 42 , unit : :meter }","ref":"Measurements.html#new/3","title":"Measurements.new/3","type":"function"},{"doc":"The ratio of two measurements, with implicit unit conversion. Only measurements with the same unit dimension will work, currently. Error will be propagated (ie relatively compounded) as an int if possible. Examples iex&gt; m1 = Measurements . time ( 300 , :second ) |&gt; Measurements . add_error ( 1 , :second ) iex&gt; m2 = Measurements . time ( 60_000 , :millisecond ) |&gt; Measurements . add_error ( 3 , :millisecond ) iex&gt; Measurements . ratio ( m1 , m2 ) % Measurements { value : 5 , unit : nil , error : 0.01691666666666667 }","ref":"Measurements.html#ratio/2","title":"Measurements.ratio/2","type":"function"},{"doc":"Scales a measurement by a number. No unit conversion happens at this stage for simplicity, and to keep the scale of the resulting value obvious. Error will be scaled by the same number, but always remains positive. Examples iex&gt; m1 = Measurements . time ( 543 , :millisecond ) |&gt; Measurements . add_error ( 3 , :millisecond ) iex&gt; Measurements . scale ( m1 , 10 ) % Measurements { value : 5430 , unit : :millisecond , error : 30 }","ref":"Measurements.html#scale/2","title":"Measurements.scale/2","type":"function"},{"doc":"The sum of multiple measurements, with implicit unit conversion. Only measurements with the same unit dimension will work. Error will be propagated. Examples iex&gt; m1 = Measurements . time ( 42 , :second ) |&gt; Measurements . add_error ( 1 , :second ) iex&gt; m2 = Measurements . time ( 543 , :millisecond ) |&gt; Measurements . add_error ( 3 , :millisecond ) iex&gt; Measurements . sum ( m1 , m2 ) % Measurements { value : 42_543 , unit : :millisecond , error : 1_003 }","ref":"Measurements.html#sum/2","title":"Measurements.sum/2","type":"function"},{"doc":"Time Measurement. Examples iex&gt; Measurements . time ( 42 , :second ) % Measurements { value : 42 , unit : :second }","ref":"Measurements.html#time/3","title":"Measurements.time/3","type":"function"},{"doc":"Measurement Type","ref":"Measurements.html#t:t/0","title":"Measurements.t/0","type":"type"},{"doc":"Measurements.Dimension deals with the dimension of a unit and related conversion","ref":"Measurements.Dimension.html","title":"Measurements.Dimension","type":"module"},{"doc":"","ref":"Measurements.Dimension.html#new/0","title":"Measurements.Dimension.new/0","type":"function"},{"doc":"","ref":"Measurements.Dimension.html#prod/2","title":"Measurements.Dimension.prod/2","type":"function"},{"doc":"","ref":"Measurements.Dimension.html#ratio/2","title":"Measurements.Dimension.ratio/2","type":"function"},{"doc":"","ref":"Measurements.Dimension.html#with_current/2","title":"Measurements.Dimension.with_current/2","type":"function"},{"doc":"","ref":"Measurements.Dimension.html#with_length/2","title":"Measurements.Dimension.with_length/2","type":"function"},{"doc":"","ref":"Measurements.Dimension.html#with_lintensity/2","title":"Measurements.Dimension.with_lintensity/2","type":"function"},{"doc":"","ref":"Measurements.Dimension.html#with_mass/2","title":"Measurements.Dimension.with_mass/2","type":"function"},{"doc":"","ref":"Measurements.Dimension.html#with_substance/2","title":"Measurements.Dimension.with_substance/2","type":"function"},{"doc":"","ref":"Measurements.Dimension.html#with_temperature/2","title":"Measurements.Dimension.with_temperature/2","type":"function"},{"doc":"","ref":"Measurements.Dimension.html#with_time/2","title":"Measurements.Dimension.with_time/2","type":"function"},{"doc":"Dimension Type","ref":"Measurements.Dimension.html#t:t/0","title":"Measurements.Dimension.t/0","type":"type"},{"doc":"Measurements.Scale deals with the scale of a unit and related conversion","ref":"Measurements.Scale.html","title":"Measurements.Scale","type":"module"},{"doc":"","ref":"Measurements.Scale.html#convert/1","title":"Measurements.Scale.convert/1","type":"function"},{"doc":"","ref":"Measurements.Scale.html#from_value/2","title":"Measurements.Scale.from_value/2","type":"function"},{"doc":"","ref":"Measurements.Scale.html#new/2","title":"Measurements.Scale.new/2","type":"function"},{"doc":"","ref":"Measurements.Scale.html#prod/2","title":"Measurements.Scale.prod/2","type":"function"},{"doc":"","ref":"Measurements.Scale.html#ratio/2","title":"Measurements.Scale.ratio/2","type":"function"},{"doc":"","ref":"Measurements.Scale.html#to_value/1","title":"Measurements.Scale.to_value/1","type":"function"},{"doc":"Scale Type","ref":"Measurements.Scale.html#t:t/0","title":"Measurements.Scale.t/0","type":"type"},{"doc":"Documentation for Measurements.Unit . A unit is represented by an atom. Ref: https://en.wikipedia.org/wiki/International_System_of_Units There exist multiple submodules defining the various units: Time TODO !! Internally, a unit relies on Scale and Dimension to determine: which conversion is allowed or not. which unit is better suited to a value. But a user does not need to know about it, it will be managed automatically, to minimize loss of precision, and keep the Measurement value in the integer range as much as possible. Examples iex&gt; Measurements.Unit . time ( :second ) { :ok , :second } iex&gt; Measurements.Unit . min ( :second , :nanosecond ) { :ok , :nanosecond } iex&gt; { :ok , converter } = Measurements.Unit . convert ( :second , :millisecond ) iex&gt; converter . ( 42 ) 42_000","ref":"Measurements.Unit.html","title":"Measurements.Unit","type":"module"},{"doc":"Conversion algorithm from a unit to another. Will find out which dimension the unnit belongs to, and if a conversion is possible.","ref":"Measurements.Unit.html#convert/2","title":"Measurements.Unit.convert/2","type":"function"},{"doc":"The dimension of the unit","ref":"Measurements.Unit.html#dimension/1","title":"Measurements.Unit.dimension/1","type":"function"},{"doc":"Normalizes a custom length unit to a known one","ref":"Measurements.Unit.html#length/2","title":"Measurements.Unit.length/2","type":"function"},{"doc":"finds out, for two units of the same dimension, which unit is more (in scale) than the other. This means the returned unit will be the least precise","ref":"Measurements.Unit.html#max/2","title":"Measurements.Unit.max/2","type":"function"},{"doc":"finds out, for two units of the same dimension, which unit is less (in scale) than the other. This means the returned unit will be the most precise","ref":"Measurements.Unit.html#min/2","title":"Measurements.Unit.min/2","type":"function"},{"doc":"Returns the module where this unit is defined. Indicates which implementation to call for normalization, conversion, etc.","ref":"Measurements.Unit.html#module/1","title":"Measurements.Unit.module/1","type":"function"},{"doc":"Normalizes a known unit, of any dimension","ref":"Measurements.Unit.html#new/1","title":"Measurements.Unit.new/1","type":"function"},{"doc":"","ref":"Measurements.Unit.html#scale/1","title":"Measurements.Unit.scale/1","type":"function"},{"doc":"Normalizes a custom time unit to a known one.","ref":"Measurements.Unit.html#time/2","title":"Measurements.Unit.time/2","type":"function"},{"doc":"","ref":"Measurements.Unit.html#to_string/1","title":"Measurements.Unit.to_string/1","type":"function"},{"doc":"Unit Type","ref":"Measurements.Unit.html#t:t/0","title":"Measurements.Unit.t/0","type":"type"},{"doc":"","ref":"Measurements.Unit.html#t:value/0","title":"Measurements.Unit.value/0","type":"type"},{"doc":"Measurements.Unit.Length deals with length-related units.","ref":"Measurements.Unit.Length.html","title":"Measurements.Unit.Length","type":"module"},{"doc":"macro used for reflection at compile time : which units are usable with this module.","ref":"Measurements.Unit.Length.html#__units/0","title":"Measurements.Unit.Length.__units/0","type":"macro"},{"doc":"","ref":"Measurements.Unit.Length.html#kilometer/0","title":"Measurements.Unit.Length.kilometer/0","type":"macro"},{"doc":"","ref":"Measurements.Unit.Length.html#meter/0","title":"Measurements.Unit.Length.meter/0","type":"macro"},{"doc":"","ref":"Measurements.Unit.Length.html#micrometer/0","title":"Measurements.Unit.Length.micrometer/0","type":"macro"},{"doc":"","ref":"Measurements.Unit.Length.html#millimeter/0","title":"Measurements.Unit.Length.millimeter/0","type":"macro"},{"doc":"","ref":"Measurements.Unit.Length.html#nanometer/0","title":"Measurements.Unit.Length.nanometer/0","type":"macro"},{"doc":"","ref":"Measurements.Unit.Length.html#to_string/1","title":"Measurements.Unit.Length.to_string/1","type":"function"},{"doc":"","ref":"Measurements.Unit.Length.html#t:t/0","title":"Measurements.Unit.Length.t/0","type":"type"},{"doc":"Measurements.Unit.Time deals with time-related units.","ref":"Measurements.Unit.Time.html","title":"Measurements.Unit.Time","type":"module"},{"doc":"macro used for reflection at compile time: which units are usable with this module.","ref":"Measurements.Unit.Time.html#__units/0","title":"Measurements.Unit.Time.__units/0","type":"macro"},{"doc":"","ref":"Measurements.Unit.Time.html#gigahertz/0","title":"Measurements.Unit.Time.gigahertz/0","type":"macro"},{"doc":"","ref":"Measurements.Unit.Time.html#hertz/0","title":"Measurements.Unit.Time.hertz/0","type":"macro"},{"doc":"","ref":"Measurements.Unit.Time.html#kilohertz/0","title":"Measurements.Unit.Time.kilohertz/0","type":"macro"},{"doc":"","ref":"Measurements.Unit.Time.html#megahertz/0","title":"Measurements.Unit.Time.megahertz/0","type":"macro"},{"doc":"","ref":"Measurements.Unit.Time.html#microsecond/0","title":"Measurements.Unit.Time.microsecond/0","type":"macro"},{"doc":"","ref":"Measurements.Unit.Time.html#millisecond/0","title":"Measurements.Unit.Time.millisecond/0","type":"macro"},{"doc":"","ref":"Measurements.Unit.Time.html#nanosecond/0","title":"Measurements.Unit.Time.nanosecond/0","type":"macro"},{"doc":"","ref":"Measurements.Unit.Time.html#second/0","title":"Measurements.Unit.Time.second/0","type":"macro"},{"doc":"","ref":"Measurements.Unit.Time.html#to_string/1","title":"Measurements.Unit.Time.to_string/1","type":"function"},{"doc":"","ref":"Measurements.Unit.Time.html#t:t/0","title":"Measurements.Unit.Time.t/0","type":"type"},{"doc":"Measurements is a library for computation of physical quantities (time, distances, etc.) in Elixir. A quantity is represented by a struct with a value, a unit and a positive error . Error is propagated through calculations, and unit prevent collision of unrelated quantities. Automatic conversion of unit (in scale) is supported. Conversion of unit, across dimension, could ultimately be supported. But is a very large endaevour and the package API is not stable enough just yet. See https://en.wikipedia.org/wiki/Dimensional_analysis as reference. Dimensions supported: [X] Time (T) [X] Length (L) [ ] Mass (M) [ ] Electric Current (I) [ ] Absolute Temperature (Θ) [ ] Amount of Substance (N) [ ] Luminous Intensity (J)","ref":"readme.html","title":"Measurements","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding measurements to your list of dependencies in mix.exs : def deps do [ { :measurements , &quot;~&gt; 0.1.2&quot; } ] end Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/measurements .","ref":"readme.html#installation","title":"Measurements - Installation","type":"extras"},{"doc":"$ mix test --trace Or for a more interactive approach: $ iex -S mix","ref":"readme.html#testing-in-iex","title":"Measurements - Testing in Iex","type":"extras"},{"doc":"Install livebook as an escript and start it: livebook server From there you can open DEMO.livemd to see measurements in action, and try it for yourself !","ref":"readme.html#testing-in-livebook","title":"Measurements - Testing in Livebook","type":"extras"},{"doc":"Optionally, setup direnv with asdf . This will allow to work with another elixir version than your system's one. Then: install it run the tests check the livebook browse the docs have a look at the code Want to change something ? open an issue to discuss Make it work open a PR to show off the work Make it beautiful Let's merge it! Make it fast","ref":"readme.html#how-to-develop","title":"Measurements - How to develop","type":"extras"},{"doc":"Mix . install ( [ { :measurements , path : &quot;.&quot; } , { :vega_lite , &quot;~&gt; 0.1.6&quot; } , { :kino_vega_lite , &quot;~&gt; 0.1.7&quot; } ] ) alias VegaLite , as : Vl","ref":"demo.html","title":"Demo","type":"extras"},{"doc":"measurements is a package helping with manipulation of real physics quantities.","ref":"demo.html#introduction","title":"Demo - Introduction","type":"extras"},{"doc":"A measurement is just a struct that can be easily created like so: Measurements . new ( 4 , :kilometer ) If desired, an associated error can be added onto that measurement Measurements . new ( 300 , :second ) |&gt; Measurements . add_error ( 4 , :millisecond ) A measurement can be converted to another unit of the same dimension Measurements . new ( 300 , :second , 5 ) |&gt; Measurements . best_convert ( :microsecond ) The best unit is chosen to avoid loosing precision. If the target unit is not better than the current one, the conversion is simply ignored. Measurements . new ( 300 , :millisecond , 5 ) |&gt; Measurements . best_convert ( :second ) This allows to operate on measurements without knowing their precision, but remaining confident no precision in lost in various computations.","ref":"demo.html#usage","title":"Demo - Usage","type":"extras"},{"doc":"Addition Measurements support addition with automated conversion, provided the unit dimension matches. m1 = Measurements . new ( 4 , :millimeter ) m2 = Measurements . new ( 543 , :micrometer , 2 ) Measurements . sum ( m1 , m2 ) Otherwise an explicit error with clean measurement representation is displayed: m1 = Measurements . new ( 4 , :second ) |&gt; Measurements . add_error ( 5 , :millisecond ) m2 = Measurements . new ( 543 , :micrometer ) Measurements . sum ( m1 , m2 ) Scaling Scaling the Measurement by a constant is also supported. Note the scale also applies to the error. m1 = Measurements . new ( 4 , :second ) |&gt; Measurements . add_error ( 5 , :millisecond ) Measurements . scale ( m1 , 60 ) Difference Therefore difference of two measurements with unit of same dimension is also supported. A more convenient delta/2 function is provided for this purpose. m1 = Measurements . new ( 4 , :millimeter ) m2 = Measurements . new ( 543 , :micrometer , 2 ) Measurements . delta ( m1 , m2 ) Ratio The ratio of two measurement is also supported. The result will be a measurement, with its unit adjusted. Therefore the nil Unit is just a constant, with potentially an error... m1 = Measurements . new ( 4 , :millimeter ) m2 = Measurements . new ( 543 , :micrometer , 2 ) Measurements . ratio ( m1 , m2 ) We can verify this result, and maybe get an exact match, even if the value is a float: [ Measurements . ratio ( m1 , m2 ) . value * 0.543 == 4 , # relative error recovery is a bit more involved. # Refer to Error propagation theory when in doubt (TODO link?) Measurements . ratio ( m1 , m2 ) . error * 543 / 2 == Measurements . ratio ( m1 , m2 ) . value ] TODO : Product This will require more involved unit dimension manipulation...","ref":"demo.html#arithmetic","title":"Demo - Arithmetic","type":"extras"},{"doc":"With the capabilities in Measurements so far, we can already implement some basic discrete calculus on physical quantities. Local Discrete Derivative TODO Local Discrete Integral TODO","ref":"demo.html#discrete-calculus","title":"Demo - Discrete Calculus","type":"extras"},{"doc":"","ref":"demo.html#iterative-control","title":"Demo - Iterative Control","type":"extras"}]